(document:surround "/std/frame")
(document:insert "/std/functions")
(document:envelop with-translation _ "alterator-datetime")

(define *pools* (make-cell '()))

(define (pool-index name lst)
  (or (list-index (lambda(x) (string=? (car x) name)) lst)
       0))

(define (get-pool)
  (car (list-ref (cell-ref *pools*)
                 (pool-list current))))

(define (update-datetime data)
  (date-set text (woo-get-option data 'date))
  (time-set text (woo-get-option data 'time)))

(define (write-datetime)
  (woo-catch/message
   (thunk
    (woo-write/constraints "/datetime"
                           'date   (date-set text)
                           'time   (time-set text)
                           'has_ntp (has-ntp state)
                           'use_ntp (use-ntp state)
                           'pool (get-pool))
    (update-datetime (woo-read-first "/datetime")))))

(document:id has-ntp 
             (checkbox "" inactive invisible widget-name "has_ntp"))
(gridbox columns "10;80;10"
         ;;
         (spacer)     
         (hbox
               (document:id use-ntp (checkbox (_ "Setup automatically:") widget-name "use_ntp" ))
               (document:id pool-list (combobox widget-name "pool")))
         (spacer)

         ;;
         (spacer)
         (hbox
          (vbox
           (label (_ "Current date:"))
           (document:id date-set (dateedit expanded #t widget-name "date")))
          
          (vbox	(label (_ "Current time:"))
                (document:id time-set (timeedit expanded #t widget-name "time"))))
         (spacer))

(or (global 'frame:next-button)
    (hbox (document:id apply-button (button (_ "Apply")))
          (button (_ "Quit") (when clicked (document:end)))))

(document:root (when loaded
                 (woo-catch/message
		  (thunk
                    (let ((pools (woo-list/name+label "/datetime/avail_pool"))
                          (data (woo-read-first "/datetime")))
                      (cell-set! *pools* pools)
                      (pool-list rows (map cdr pools)
                                 current (pool-index (woo-get-option data 'pool)
                                                     pools))

                      (update-datetime data)
		      (has-ntp state (woo-get-option data 'has_ntp))
		      (use-ntp state (woo-get-option data 'use_ntp)))
		    (apply-button (when clicked (write-datetime)))
		    (update-constraints "write" "/datetime")))))

(frame:on-next (thunk (or (write-datetime) 'cancel)))
(frame:on-back (thunk (or (write-datetime) 'cancel)))

(and (global 'frame:auto-save)
     (cell-set! (global 'frame:auto-save) write-datetime))
